<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" /><meta name="generator" content="Docutils 0.18.1: http://docutils.sourceforge.net/" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Pipe flow &mdash; cflowpy Jule 2023 documentation</title>
      <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="../_static/css/theme.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="../_static/jquery.js"></script>
        <script src="../_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
        <script src="../_static/doctools.js"></script>
        <script src="../_static/sphinx_highlight.js"></script>
        <script async="async" src="https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-mml-chtml.js"></script>
    <script src="../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Pipe with a backward facing step" href="pipe_with_a_backward_facing_step.html" />
    <link rel="prev" title="Physical Problem" href="../physical_problem.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../index.html" class="icon icon-home">
            cflowpy
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">cflowpy:</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../tutorial.html">Tutorial</a></li>
<li class="toctree-l1"><a class="reference internal" href="../grid.html">Grid</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../physical_problem.html">Physical Problem</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="../physical_problem.html#constructor">Constructor</a></li>
<li class="toctree-l2"><a class="reference internal" href="../physical_problem.html#system-initialisation">System initialisation</a></li>
<li class="toctree-l2"><a class="reference internal" href="../physical_problem.html#boundary-conditions">Boundary Conditions</a></li>
<li class="toctree-l2 current"><a class="reference internal" href="../physical_problem.html#subclasses">Subclasses</a><ul class="current">
<li class="toctree-l3 current"><a class="current reference internal" href="#">Pipe flow</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#constructor">Constructor</a></li>
<li class="toctree-l4"><a class="reference internal" href="#system-initialisation">System initialisation</a></li>
<li class="toctree-l4"><a class="reference internal" href="#boundary-conditions">Boundary Conditions</a></li>
<li class="toctree-l4"><a class="reference internal" href="#expected-results">Expected Results</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="#pressure-driven-pipe-flow">Pressure driven pipe flow</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#id1">Constructor</a></li>
<li class="toctree-l4"><a class="reference internal" href="#id2">System initialisation</a></li>
<li class="toctree-l4"><a class="reference internal" href="#id3">Boundary Conditions</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="pipe_with_a_backward_facing_step.html">Pipe with a backward facing step</a></li>
<li class="toctree-l3"><a class="reference internal" href="cavity_flow.html">Cavity flow</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../integrator.html">Integrator</a></li>
<li class="toctree-l1"><a class="reference internal" href="../system.html">Solving the incompressible Navier-Stokes Equation</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../index.html">cflowpy</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../physical_problem.html">Physical Problem</a></li>
      <li class="breadcrumb-item active">Pipe flow</li>
      <li class="wy-breadcrumbs-aside">
            <a href="../_sources/PhysicalProblems/pipe_flow.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="pipe-flow">
<h1>Pipe flow<a class="headerlink" href="#pipe-flow" title="Permalink to this heading"></a></h1>
<div class="line-block">
<div class="line"><code class="docutils literal notranslate"><span class="pre">Pipe_flow</span></code> describes a typical flow of a incompressible fluid in a pipe.</div>
<div class="line">Simulating such a pipe, the Hagen-Poiseuille velocity profile is Expected
as a result.</div>
</div>
<dl class="py class">
<dt class="sig sig-object py">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">src.</span></span><span class="sig-name descname"><span class="pre">Pipe_flow</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">u_left</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em><span class="sig-paren">)</span></dt>
<dd><p>This class is used to simulate a pipe.</p>
<p>At the left edge of the domain there is used
a Dirichlet boundary condition.
(velocity going into the pipe)
We assume the pipe to be long enough to get the full velocity profile.
To do so, there are used Neumann boundary conditions on the right edge
of the domain.
To assure the no-slip condition there are used Dirichlet boundary
conditions at the top and bottom edge of the domain to ensure the
velocity is zero there.</p>
<dl class="py attribute">
<dt class="sig sig-object py">
<span class="sig-name descname"><span class="pre">u_left</span></span></dt>
<dd><p>Velocity at the left side of the domain in x-direction</p>
<dl class="field-list simple">
<dt class="field-odd">Type<span class="colon">:</span></dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

<section id="constructor">
<h2>Constructor<a class="headerlink" href="#constructor" title="Permalink to this heading"></a></h2>
<blockquote>
<div><div class="admonition hint">
<p class="admonition-title">Hint</p>
<div class="line-block">
<div class="line">The number of Cells for each direction should be between
<span class="math notranslate nohighlight">\((x_n-x_0) \leq n_i \leq (x_n-x_0)\cdot 50\)</span> where
<span class="math notranslate nohighlight">\(x_n\)</span> is the end of the domain, <span class="math notranslate nohighlight">\(x_0\)</span> the begin
of the domain and <span class="math notranslate nohighlight">\(n_i\)</span> the number of cells, for each dimension.</div>
<div class="line"><strong>Note:</strong> This might differ for some specific discretization like very
small or very large computational domains.</div>
<div class="line">Furthermore it is suggested to use a non-quadratic grid with, e.g.
<span class="math notranslate nohighlight">\(n_x = 3\cdot n_y\)</span>.</div>
</div>
</div>
</div></blockquote>
<dl class="py method">
<dt class="sig sig-object py" id="src.Pipe_flow.__init__">
<span class="sig-prename descclassname"><span class="pre">Pipe_flow.</span></span><span class="sig-name descname"><span class="pre">__init__</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">u_left</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.Pipe_flow.__init__" title="Permalink to this definition"></a></dt>
<dd><p>Constructor</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><p><strong>u_left</strong> (<em>float</em>) – Velocity in x-direction going from the left side into the domain.</p>
</dd>
<dt class="field-even">Raises<span class="colon">:</span></dt>
<dd class="field-even"><p><strong>TypeError</strong> – If u_left is no number</p>
</dd>
</dl>
</dd></dl>

<div class="line-block">
<div class="line">If it is wished to simulate a pipe with an inflow velocity of 5 in x-direction
this can be done with:</div>
</div>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="n">physical_problem</span> <span class="o">=</span> <span class="n">src</span><span class="o">.</span><span class="n">Pipe_flow</span><span class="p">(</span><span class="mi">5</span><span class="p">)</span>
</pre></div>
</div>
</section>
<section id="system-initialisation">
<h2>System initialisation<a class="headerlink" href="#system-initialisation" title="Permalink to this heading"></a></h2>
<div class="line-block">
<div class="line">The system is initialised with the inflow velocity in x-direction
and zero velocity in y-direction and pressure.</div>
</div>
</section>
<section id="boundary-conditions">
<h2>Boundary Conditions<a class="headerlink" href="#boundary-conditions" title="Permalink to this heading"></a></h2>
<div class="line-block">
<div class="line">For the velocity there are used Dirichlet boundary conditions at the
left side of the domain.</div>
<div class="line">Neumann boundary conditions are used at the right side.
The domain is assumed to be large enough that the velocity is not changing
at the right side of the domain.</div>
<div class="line">At the bottom and top edge of the pipe the no-slip condition is applied.</div>
<div class="line">For the pressure there are used Neumann boundary conditions at every side.</div>
</div>
<dl class="py method">
<dt class="sig sig-object py" id="src.Pipe_flow.apply_bcs_velocity">
<span class="sig-prename descclassname"><span class="pre">Pipe_flow.</span></span><span class="sig-name descname"><span class="pre">apply_bcs_velocity</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">u</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">v</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.Pipe_flow.apply_bcs_velocity" title="Permalink to this definition"></a></dt>
<dd><p>Applies the boundary conditions for the velocity field.</p>
<p>Applies Dirichlet boundary conditions on the left side of the domain.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>u</strong> (<em>np.ndarray</em>) – velocity field in x-direction</p></li>
<li><p><strong>v</strong> (<em>np.ndarray</em>) – velocity field in y-direction</p></li>
</ul>
</dd>
<dt class="field-even">Raises<span class="colon">:</span></dt>
<dd class="field-even"><p><strong>TypeError</strong> – If one of the inputs is no numpy ndarray</p>
</dd>
<dt class="field-odd">Returns<span class="colon">:</span></dt>
<dd class="field-odd"><p>Velocity fields after applying the boundary conditions</p>
</dd>
<dt class="field-even">Return type<span class="colon">:</span></dt>
<dd class="field-even"><p>np.ndarray, np.ndarray</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="src.Pipe_flow.apply_bcs_pressure">
<span class="sig-prename descclassname"><span class="pre">Pipe_flow.</span></span><span class="sig-name descname"><span class="pre">apply_bcs_pressure</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">p</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.Pipe_flow.apply_bcs_pressure" title="Permalink to this definition"></a></dt>
<dd><p>Applies the boundary conditions for the pressure field.</p>
<p>Applies Neumann boundary conditions on each side of the domain.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><p><strong>p</strong> (<em>np.ndarray</em>) – pressure field</p>
</dd>
<dt class="field-even">Raises<span class="colon">:</span></dt>
<dd class="field-even"><p><strong>TypeError</strong> – If the pressure field is no numpy ndarray</p>
</dd>
<dt class="field-odd">Returns<span class="colon">:</span></dt>
<dd class="field-odd"><p>Pressure field after applying the boundary conditions</p>
</dd>
<dt class="field-even">Return type<span class="colon">:</span></dt>
<dd class="field-even"><p>np.ndarray</p>
</dd>
</dl>
</dd></dl>

</section>
<section id="expected-results">
<h2>Expected Results<a class="headerlink" href="#expected-results" title="Permalink to this heading"></a></h2>
<div class="line-block">
<div class="line">For now we stick with the example from above and assume an inflow of 5[<span class="math notranslate nohighlight">\(\frac{m}{s}\)</span>].</div>
<div class="line">In this case the Hagen-Poiseuille velocity profile is expected.</div>
<div class="line">Such a simulation can be run with:</div>
</div>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">cflowpy</span> <span class="k">as</span> <span class="nn">cf</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">physical_problem_pipe</span> <span class="o">=</span> <span class="n">cf</span><span class="o">.</span><span class="n">Pipe_flow</span><span class="p">(</span><span class="mi">5</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">system</span> <span class="o">=</span> <span class="n">cf</span><span class="o">.</span><span class="n">System</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="mi">10</span><span class="p">,</span> <span class="mi">40</span><span class="p">,</span>
<span class="go">                        0, 2, 20,</span>
<span class="go">                        0.1, 1.,</span>
<span class="go">                        physical_problem_pipe)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">u</span><span class="p">,</span> <span class="n">v</span><span class="p">,</span> <span class="n">p</span> <span class="o">=</span> <span class="n">system</span><span class="o">.</span><span class="n">solve</span><span class="p">(</span><span class="mf">0.01</span><span class="p">,</span> <span class="mi">5</span><span class="p">,</span>
<span class="go">                           time_update=&quot;Runge_Kutta_4&quot;,</span>
<span class="go">                           adapt_dt = 0.5)</span>
</pre></div>
</div>
<div class="line-block">
<div class="line">A domain of <span class="math notranslate nohighlight">\(x \in [0,10], y \in [0,2]\)</span> with 25 cells in x-direction and
5 cells in y-direction is used.</div>
<div class="line">In this case we use a kinematic viscosity of <span class="math notranslate nohighlight">\(0.1[\frac{mm^2}{s}]\)</span>
and a density of <span class="math notranslate nohighlight">\(1[\frac{kg}{mm^3}]\)</span></div>
<div class="line">The time step size is 0.01 seconds and 5 seconds are simulated.</div>
<div class="line">Furthermore, we used the Runge Kutta 4 algorithm to step forward in time.</div>
<div class="line">If the cfl-condition is not fullfilled we adapt the time step size to
set the cfl-number on 0.5.</div>
</div>
<p>The Result can be visualized with:</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="n">fig</span> <span class="o">=</span> <span class="n">chorin</span><span class="o">.</span><span class="n">contourfigure</span><span class="p">(</span><span class="n">u</span><span class="p">,</span> <span class="n">v</span><span class="p">,</span> <span class="n">p</span><span class="p">,</span>
<span class="go">                               contour=False,</span>
<span class="go">                               velocity_profile = [5, 15, 25],</span>
<span class="go">                               title=&quot;Velocity profile in a pipe&quot;)</span>
</pre></div>
</div>
<a class="reference internal image-reference" href="../_images/Pipe_flow.png"><img alt="../_images/Pipe_flow.png" src="../_images/Pipe_flow.png" style="width: 600px;" /></a>
</section>
</section>
<section id="pressure-driven-pipe-flow">
<h1>Pressure driven pipe flow<a class="headerlink" href="#pressure-driven-pipe-flow" title="Permalink to this heading"></a></h1>
<div class="line-block">
<div class="line"><code class="docutils literal notranslate"><span class="pre">Pipe_flow_pressure_driven</span></code> gives the opportunity to prescribe the
pressure on the boundaries with Dirichlet boundary conditions.</div>
<div class="line">The pressure on the domain is linearly interpolated from this
boundary values.</div>
</div>
<blockquote>
<div><div class="admonition warning">
<p class="admonition-title">Warning</p>
<div class="line-block">
<div class="line">In this case, it is highly recommended to set
<code class="docutils literal notranslate"><span class="pre">n_iteration_pressure_poisson</span></code> to zero, when using <code class="docutils literal notranslate"><span class="pre">solve</span></code>
from <code class="docutils literal notranslate"><span class="pre">System</span></code>, since the pressure is prescribed and so we
do not need to solve the Poisson equation and can save a lot
of computational effort.</div>
</div>
</div>
<div class="admonition hint">
<p class="admonition-title">Hint</p>
<div class="line-block">
<div class="line">The suggested number of cells is the same as in <a class="reference internal" href="#"><span class="doc">Pipe flow</span></a>.</div>
</div>
</div>
</div></blockquote>
<section id="id1">
<h2>Constructor<a class="headerlink" href="#id1" title="Permalink to this heading"></a></h2>
<dl class="py method">
<dt class="sig sig-object py" id="src.Pipe_flow_pressure_driven.__init__">
<span class="sig-prename descclassname"><span class="pre">Pipe_flow_pressure_driven.</span></span><span class="sig-name descname"><span class="pre">__init__</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">u_left</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">p_left</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">p_right</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.Pipe_flow_pressure_driven.__init__" title="Permalink to this definition"></a></dt>
<dd><p>Constructor</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>u_left</strong> (<em>float</em>) – Velocity at the left edge of the domain in x-direction</p></li>
<li><p><strong>p_left</strong> (<em>float</em>) – Pressure at the left edge of the domain</p></li>
<li><p><strong>p_right</strong> (<em>float</em>) – Pressure at the right edge of the domain</p></li>
</ul>
</dd>
<dt class="field-even">Raises<span class="colon">:</span></dt>
<dd class="field-even"><ul class="simple">
<li><p><strong>TypeError</strong> – If u_left is no number</p></li>
<li><p><strong>TypeError</strong> – If either p_left or p_right is no number</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<div class="line-block">
<div class="line">If it is wished to simulate a pipe with no inflow and a prescribed pressure
of 10:math:<cite>frac{N}{m^2}</cite> on the left side and 0:math:<cite>frac{N}{m^2}</cite> on
the right side, this can be done with:</div>
</div>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="n">physical_problem</span> <span class="o">=</span> <span class="n">src</span><span class="o">.</span><span class="n">Pipe_flow_pressure_driven</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="mi">10</span><span class="p">,</span> <span class="mi">0</span><span class="p">)</span>
</pre></div>
</div>
</section>
<section id="id2">
<h2>System initialisation<a class="headerlink" href="#id2" title="Permalink to this heading"></a></h2>
<div class="line-block">
<div class="line">This system is initialised the same as <code class="docutils literal notranslate"><span class="pre">Pipe_flow</span></code>, however the
pressure is initialised with the prescribed pressure gradient.</div>
</div>
</section>
<section id="id3">
<h2>Boundary Conditions<a class="headerlink" href="#id3" title="Permalink to this heading"></a></h2>
<div class="line-block">
<div class="line">The boundary conditions are the same as for <code class="docutils literal notranslate"><span class="pre">Pipe_flow</span></code>, with one
difference.</div>
<div class="line">The pressure is described with Dirichlet boundary condition on
the left and right side of the domain.</div>
<div class="line">The pressure in the domain itself is interpolated from this
boundary values.</div>
</div>
<dl class="py method">
<dt class="sig sig-object py" id="src.Pipe_flow_pressure_driven.apply_bcs_velocity">
<span class="sig-prename descclassname"><span class="pre">Pipe_flow_pressure_driven.</span></span><span class="sig-name descname"><span class="pre">apply_bcs_velocity</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">u</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">v</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.Pipe_flow_pressure_driven.apply_bcs_velocity" title="Permalink to this definition"></a></dt>
<dd><p>Applies boundary conditions for velocity using parent class.</p>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="src.Pipe_flow_pressure_driven.apply_bcs_pressure">
<span class="sig-prename descclassname"><span class="pre">Pipe_flow_pressure_driven.</span></span><span class="sig-name descname"><span class="pre">apply_bcs_pressure</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">p</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.Pipe_flow_pressure_driven.apply_bcs_pressure" title="Permalink to this definition"></a></dt>
<dd><p>Applies boundary conditions for the pressure</p>
<p>Pressure driven Pipe
The pressure on the left and right side of the domain are prescriben
and the pressure inside the domain is interpolated from this.
Therefore it can be useful to set “n_iteration_pressure_poisson”
to zero, when solving the incompressible Navier-Stokes equation
with “System”.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><p><strong>p</strong> (<em>np.ndarray</em>) – pressure field</p>
</dd>
<dt class="field-even">Raises<span class="colon">:</span></dt>
<dd class="field-even"><p><strong>TypeError</strong> – If the pressure field is no numpy ndarray</p>
</dd>
<dt class="field-odd">Returns<span class="colon">:</span></dt>
<dd class="field-odd"><p>Pressure field after applying the boundary conditions</p>
</dd>
<dt class="field-even">Return type<span class="colon">:</span></dt>
<dd class="field-even"><p>np.ndarray</p>
</dd>
</dl>
</dd></dl>

</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="../physical_problem.html" class="btn btn-neutral float-left" title="Physical Problem" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="pipe_with_a_backward_facing_step.html" class="btn btn-neutral float-right" title="Pipe with a backward facing step" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2023, Jan Habscheid.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>